HDU Hotaru's problem(Manacher算法+贪心)

manacher算法详见

http://blog.csdn.net/u014664226/article/details/47428293

题意:给一个序列,让求其最大子序列,这个子序列由三段组成,第一段和第二段对称,第一段和第三段一样。

思路:首先利用Manacher算法求出以任意两个相邻元素为中心的回文串长度,用a[i]表示i-1,i为中心的回文串长度的一半,

那么问题就转化成了求最大的x,使得a[i]>=x,a[i+x]>=x,这一步可以贪心来做。

将a[i]从大到小排序(间接排序保留下标),设a[i]在原序列的下标为j,

每次将j放入set中,然后二分找到下标大于等于j-a[i]的最小值和下标小于等于j+a[i]的最大值,

这样可以就求出ans

</pre><pre class="cpp" name="code">#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
#include<queue>
#include<stack>
#include<string>
#include<map>
#include<set>
#define eps 1e-6
#define LL long long
#define pii (pair<int, int>)
//#pragma comment(linker, "/STACK:1024000000,1024000000")
using namespace std;

const int maxn = 2*100000+1000;
const int INF = 0x3f3f3f3f;
int s[maxn];
int p[maxn], n, a[maxn], r[maxn];
bool cmp(int t1, int t2) {
    return a[t1] > a[t2];
}
set<int> Set;
struct Manacher {
    void solve() {
        int len=n,id=0,maxlen=0;
        for(int i=len;i>=0;--i){//插入'#'
            s[i+i+2]=s[i];
            s[i+i+1]=-1;
        }
        s[0]=-2;
        for(int i=2;i<2*len+1;++i){
            if(p[id]+id>i)p[i]=min(p[2*id-i],p[id]+id-i);
            else p[i]=1;
            while(s[i-p[i]] == s[i+p[i]])++p[i];
            if(id+p[id]<i+p[i])id=i;
            if(maxlen<p[i])maxlen=p[i];
        }
    }
} manacher;

int main() {
    //freopen("input.txt", "r", stdin);
    int T; cin >> T;
    int kase = 0;
    while(T--) {
        scanf("%d", &n);
        for(int i = 0; i < n; i++) scanf("%d", &s[i]);
        s[n] = -3;
        manacher.solve();
        int cnt = 0;
        for(int i = 3; i <= 2*n; i += 2) {
            a[++cnt] = (p[i]-1)/2;
            r[cnt] = cnt;
        }
        //for(int i = 1; i <= cnt; i++) cout << a[i] << endl;
        sort(r+1, r+cnt+1, cmp);
        Set.clear(); int ans = 0;
        for(int i = 1; i <= cnt; i++) {
            Set.insert(r[i]);
            set<int>::iterator t1 = Set.lower_bound(r[i]-a[r[i]]);
            set<int>::iterator t2 = --Set.upper_bound(r[i]+a[r[i]]);
            ans = max(ans, max(r[i]-*t1, *t2-r[i]));
        }
        ans *= 3;
        printf("Case #%d: %d\n", ++kase, ans);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

HDU Hotaru's problem(Manacher算法+贪心)

时间: 2024-10-02 15:53:54

HDU Hotaru's problem(Manacher算法+贪心)的相关文章

HDU 5371(2015多校7)-Hotaru&#39;s problem(Manacher算法求回文串)

题目地址:HDU 5371 题意:给你一个具有n个元素的整数序列,问你是否存在这样一个子序列,该子序列分为三部分,第一部分与第三部分相同,第一部分与第二部分对称,如果存在求最长的符合这种条件的序列. 思路:用Manacher算法来处理回文串的长度,记录下以每一个-1(Manacher算法的插入)为中心的最大回文串的长度.然后从最大的开始穷举,只要p[i]-1即能得出以数字为中心的最大回文串的长度,然后找到右边对应的'-1',判断p[i]是不是大于所穷举的长度,如果当前的满足三段,那么就跳出,继续

HDU 5371 (2015多校联合训练赛第七场1003)Hotaru&#39;s problem(manacher+二分/枚举)

HDU 5371 题意: 定义一个序列为N序列:这个序列按分作三部分,第一部分与第三部分相同,第一部分与第二部分对称. 现在给你一个长为n(n<10^5)的序列,求出该序列中N序列的最大长度. 思路: 来自官方题解:修正了一些题解错别字(误 先用求回文串的Manacher算法,求出以第i个点为中心的回文串长度,记录到数组p中 要满足题目所要求的内容,需要使得两个相邻的回文串,共享中间的一部分,也就是说,左边的回文串长度的一半,要大于等于共享部分的长度,右边回文串也是一样. 因为我们已经记录下来以

HDU 5371 Hotaru&#39;s problem manacher+(线段树or set)

题意,给定一个100000 的串,求他一个子串,使得将子串分成三部分有后,第一部分=第三部分,第一部分与第二部分对称(回文) 首先我们需要处理出以i为轴的回文串的两端,这个事情可以用Manacher算法完成,复杂度O(n) http://blog.csdn.net/ggggiqnypgjg/article/details/6645824/ 这个博客写的很好懂.不会的童鞋可以去学习一下这个算法,非常精妙. 好的现在我们已经会了这个算法,并获得了每个点为轴的串的右端点p[i] 很简单地可以处理出左端

HDU 5371 Hotaru&#39;s problem(manacher + 枚举啊)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5371 Problem Description Hotaru Ichijou recently is addicated to math problems. Now she is playing with N-sequence. Let's define N-sequence, which is composed with three parts and satisfied with the foll

HDOJ 5371 Hotaru&#39;s problem manacher+优先队列+二分

先用求回文串的Manacher算法,求出以第i个点和第i+1个点为中心的回文串长度,记录到数组c中 比如 10 9 8 8 9 10 10 9 8 我们通过运行Manacher求出第i个点和第i+1个点为中心的回文串长度 0 0 6 0 0 6 0 0 0 两个8为中心,10 9 8 8 9 10是个回文串,长度是6. 两个10为中心,8 9 10 10 9 8是个回文串,长度是6. 要满足题目所要求的内容,需要使得两个相邻的回文串,共享中间的一部分,比如上边的两个字符串,共享 8 9 10这一

HDU 4864 Task(基本算法-贪心)

Task Problem Description Today the company has m tasks to complete. The ith task need xi minutes to complete. Meanwhile, this task has a difficulty level yi. The machine whose level below this task's level yi cannot complete this task. If the company

HDU 3294 Girls&#39; research (Manacher算法 + 记录区间)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3294 题目大意:输入一个字符ch和一个字符串,问如果把ch当作'a'的话,字符串的每个字符也要做相应变化,如b aa,若b为'a',则b前面的a就为'a'前面的'z',这里是循环表示,输出字符串的最长回文子串,如果最长回文子串串长为1,输出No solution! 几乎是模板题,唯一的特别之处就是要输出回文串字符,所以要记录max(Mp[i])对应的在原串中的字符区间,根据Manacher算法的步骤

hdu5371Hotaru&amp;#39;s problem manacher算法

//给一个序列.让求其最大子序列 //这个序列由三段组成.第一段和第二段对称,第一段和第三段一样 //manacher算法求得p[i] //枚举第二段的起点和长度,得到结果 #include<cstdio> #include<cstring> #include<iostream> using namespace std ; const int maxn = 2e5 + 10 ; int str[maxn] ; int p[maxn] ; void pk(int n) {

hdu5371Hotaru&#39;s problem manacher算法

//给一个序列,让求其最大子序列 //这个序列由三段组成,第一段和第二段对称,第一段和第三段一样 //manacher算法求得p[i] //枚举第二段的起点和长度,得到结果 #include<cstdio> #include<cstring> #include<iostream> using namespace std ; const int maxn = 2e5 + 10 ; int str[maxn] ; int p[maxn] ; void pk(int n) {